//Mesh.MshFileVersion = 1.6; 
// Version of the MSH file format to use

// epj=0.2;
// 
// hau=9.36;
// lon=216;
// lonfis=127;
// 
// nbp_h = 10;
// nbp_j=61; 
// nbp_f=40;

// epj=0.05;
// 
// hau = 4;
// lon = 200;
// lonfis=30;
// 
// nbp_h = 13;
// nbp_j = 250;
// nbp_f = 30;


epj=0.05;

hau=6;
lon=200;
lonfis=100;

nbp_h = 5;
nbp_j=501; 
nbp_f=50;

///////////////////////// POINTS ///////////////////////////



// FACE AVANT 

Point(3) = {lon,     epj/2, 0, 1};
Point(4) = {lonfis,  epj/2, 0, 1};
Point(5) = {lon,     hau, 0, 1};
Point(6) = {0,       hau, 0, 1};
Point(7) = {0,       epj/2, 0, 1};
Point(8) = {lonfis,  hau, 0, 1};

//Characteristic Length {8,4} = 2;
//Characteristic Length {6,7} = 1;

// DCB_POINTS
Physical Point(962) = {3};
Physical Point(960) = {4};
Physical Point(953) = {5};
Physical Point(950) = {6};
Physical Point(954) = {7};
Physical Point(964) = {8};

Line(966) = {7,4};
Line(967) = {4,3};
Line(968) = {5,3};
Line(969) = {5,8};
Line(970) = {8,4};
Line(971) = {6,8};
Line(972) = {6,7};

Transfinite Line {967} = nbp_j Using Progression 1;
Transfinite Line {972} = 4     Using Progression 1;


//Transfinite Line {969} = nbp_j Using Progression 1;

/*Transfinite Line {966} = nbp_f Using Progression 0.96;
Transfinite Line {971} = nbp_f Using Progression 0.96;
Transfinite Line {972} = nbp_h Using Progression 0.75;
Transfinite Line {970} = nbp_h Using Progression 0.75;
Transfinite Line {968} = nbp_h Using Progression 0.75;*/

Line Loop(973) = {970,967,-968,969};
Ruled Surface(974) = {973};
Line Loop(975) = {-971,972,966,-970};
Ruled Surface(976) = {975};

//Transfinite Surface {974} = {8,5,3,4};
//Transfinite Surface {976} = {6,8,4,7};
//Transfinite Surface {974} = {8,5,3,4};
//Transfinite Surface {976} = {6,8,4,7};
//Recombine Surface {974};
//Recombine Surface {976};

Characteristic Length {3,4} = 0.08;
Characteristic Length {8,5} = 2;
Characteristic Length {6,7} = 3;


NbCouche=1;

// EXTRUDE ANCIENNE SYNTAXE (1.60.1)
vj[]=Extrude Line {967, {0,-epj,0}}
             {
               Layers{NbCouche,1}; Recombine;
             };;
             

//DCB_G
Physical Line(981) = {972};
//DCB_D
Physical Line(982) = {968};

//DCB_JH
Physical Line(983) = {967};
//DCB_JB
//Physical Line(984) = {977};
Physical Line(984) = {vj[0]};
//DCB_HG
Physical Line(985) = {971};
//DCB_HD
Physical Line(986) = {969};
//DCB_BG
Physical Line(987) = {966};


// DCB1 (partie gauche)
Physical Surface(988) = {976};
//DCB2 (partie droite)
Physical Surface(989) = {974};
//DCBJ
//Physical Surface(990) = {980};
Physical Surface(990) = {vj[1]};
