Mesh.MshFileVersion = 1.6; 
// Version of the MSH file format to use

epj=0.1;

prof=-6;
nbp_prof=5;

hau=2;
nbp_h = 4;

lon=20;
nbp_j=15; 

lonfis=5;
nbp_f=5;


///////////////////////// POINTS ///////////////////////////



// FACE AVANT 
Point(3) = {lon, epj/2, 0, 1};
Point(4) = {lonfis,  epj/2, 0, 1};
Point(5) = {lon, hau, 0, 1};
Point(6) = {0,  hau, 0, 1};
Point(7) = {0,  epj/2, 0, 1};
Point(8) = {lonfis,  hau, 0, 1};

// FACE ARRIERE 
Point(32) = {lon,      epj/2, prof, 1};
Point(42) = {lonfis,   epj/2, prof, 1};
Point(52) = {lon,       hau,  prof, 1};
Point(62) = {0,         hau,  prof, 1};
Point(72) = {0,         epj/2,  prof, 1};
Point(82) = {lonfis,    hau,  prof, 1};

// DCB_POINTS
Physical Point(950) = {6};
Physical Point(951) = {62};
Physical Point(952) = {52};
Physical Point(953) = {5};
Physical Point(954) = {7};
Physical Point(955) = {72};
Physical Point(960) = {4};
Physical Point(961) = {42};
Physical Point(962) = {3};
Physical Point(963) = {32};
Physical Point(964) = {8};
Physical Point(965) = {82};


Line(966) = {7,4};
Line(967) = {4,3};
Line(968) = {3,5};
Line(969) = {5,8};
Line(970) = {8,4};
Line(971) = {6,8};
Line(972) = {6,7};
Line(973) = {7,72};
Line(974) = {72,62};
Line(975) = {62,6};
Line(976) = {62,82};
Line(977) = {82,42};
Line(978) = {72,42};
Line(979) = {42,4};
Line(980) = {82,8};
Line(981) = {82,52};
Line(982) = {52,32};
Line(983) = {32,3};
Line(984) = {5,52};
Line(985) = {32,42};


Characteristic Length {3,32,4,42} = 0.7;
Characteristic Length {8,82,52,5} = 0.9;
Characteristic Length {6,7,72,62} = 1.6;


Line Loop(986) = {969,970,967,968};
Ruled Surface(987) = {986};
Line Loop(988) = {984,982,983,968};
Ruled Surface(989) = {988};
Line Loop(990) = {981,982,985,-977};
Ruled Surface(991) = {990};
Line Loop(992) = {-971,972,966,-970};
Ruled Surface(993) = {992};
Line Loop(994) = {975,972,973,974};
Ruled Surface(995) = {994};
Line Loop(996) = {976,977,-978,974};
Ruled Surface(997) = {996};
Line Loop(998) = {980,970,-979,-977};
Ruled Surface(999) = {998};
Line Loop(1000) = {967,-983,985,979};
Ruled Surface(1001) = {1000};
Line Loop(1002) = {984,-981,980,-969};
Ruled Surface(1003) = {1002};
Line Loop(1004) = {980,-971,-975,976};
Ruled Surface(1005) = {1004};
Line Loop(1006) = {-978,-973,966,-979};
Ruled Surface(1007) = {1006};
Surface Loop(1008) = {1003,-989,991,-1001,987,-999};
Volume(1009) = {1008};
Surface Loop(1010) = {1005,-999,-993,995,1007,-997};
Volume(1011) = {1010};


// s1[0] contient le numero de la ligne extr?it
// s1[0]+1 et s1[0]+2 sont les numeros des lignes "de bord"
// s1[1] contient le numero de la surface cr?e
NbCouche=1;

// EXTRUDE ANCIENNE SYNTAXE (1.60.1)
vj[]=Extrude Surface {1001, {0,-epj,0}}
             {
               Layers{NbCouche,1}; Recombine;
             };;
             

// DCB_1 GAUCHE HAUT
Physical Line(1017) = {975};

// DCB_1 GAUCHE BAS
Physical Line(1018) = {973};

// DCB GAUCHE
Physical Surface(1012) = {995};

// DCB DROITE
Physical Surface(1013) = {989};

// DCB_2 BAS
Physical Surface(1014) = {1001};

// DCB_1
Physical Volume(1015) = {1011};

// DCB_2
Physical Volume(1016) = {1009};

// BAS JOINT
Physical Surface(1019) = {vj[0]};

// DCB_JOINT
Physical Volume(1020) = {vj[1]};


