#@ MODIF czm_tac_mix Comportement  DATE 06/04/2009   AUTEUR DURAND C.DURAND 
# -*- coding: iso-8859-1 -*-
#            CONFIGURATION MANAGEMENT OF EDF VERSION
# ======================================================================
# COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
# IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
# THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
# (AT YOUR OPTION) ANY LATER VERSION.                                                  
#                                                                       
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
# WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
#                                                                       
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        
# ======================================================================
# RESPONSABLE LAVERNE J.LAVERNE

from cata_comportement import LoiComportement

loi = LoiComportement(
   nom            = 'CZM_TAC_MIX',
   doc = """Relation de comportement cohsive (Cohesive Zone Model TAlon-Curnier MIXte) (Cf. [R7.02.11]) modlisant l'ouverture et la 
   propagation d'une fissure. Cette loi est utilisable avec l'lment fini d'interface bas sur une formulation mixte
   lagrangien augment (Cf. [R3.06.13]) et permet d'introduire une force de cohsion entre les lvres de la fissure dans les
   trois modes de rupture avec une irrversibilit de type Talon-Curnier. 
   Attention, cette loi ne peut tre utilise lorsqu'on impose des conditions de symtrie sur l'lment d'interface. 
   Dans ce cas de figure il faut utiliser CZM_OUV_MIX.
   Par ailleurs l'utilisation de ce modle requiert souvent la prsence du pilotage par PRED_ELAS (cf. [U4.51.03]).""",
   num_lc         = 41,
   nb_vari        = 9,
   nom_vari       = ('SEUILDEP','INDIDISS','INDIENDO','PCENERDI','DISSIP','ENEL_RES','SAUT_N','SAUT_T1','SAUT_T2'),
   mc_mater       = ('RUPT_FRAG'),
   modelisation   = ('3D','PLAN','AXIS','INTERFAC'),
   deformation    = ('PETIT'),
   nom_varc       = None,
   schema         = ('IMPLICITE'),
   type_matr_tang = ('PERTURBATION', 'VERIFICATION'),
   proprietes     = ('PRED_ELAS'),
)

