#@ MODIF norton_hoff Comportement  DATE 08/12/2009   AUTEUR PROIX J-M.PROIX 
# -*- coding: iso-8859-1 -*-
#            CONFIGURATION MANAGEMENT OF EDF VERSION
# ======================================================================
# COPYRIGHT (C) 1991 - 2008  EDF R&D                  WWW.CODE-ASTER.ORG
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
# IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
# THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
# (AT YOUR OPTION) ANY LATER VERSION.                                                  
#                                                                       
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
# WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
#                                                                       
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        
# ======================================================================
# RESPONSABLE MICHEL S.MICHEL

from cata_comportement import LoiComportement

loi = LoiComportement(
   nom            = 'NORTON_HOFF',
   doc = """Loi de visco-plasticit  indpendante de la temprature, rgularisant la loi rigide-plastique de Von Mises 
    utiliser pour le calcul de charges limites de structures,  seuil de VON MISES. 
   Le seul paramtre matriau est la limite d'lasticit  renseigner dans l'oprateur DEFI_MATERIAU [U4.43.01] 
   sous le mot-cl ECRO_LINE (Cf. [R7.07.01] et [R5.03.12] pour plus de dtails). 
   Pour le calcul de la charge limite, il existe un mot cl spcifique sous PILOTAGE pour ce modle 
   (voir mot cl PILOTAGE='ANA_LIM' de STAT_NON_LINE [U4.51.03]). 
   Il est fortement conseill d'employer de la recherche linaire (voir mot cl RECH_LINEAIRE de STAT_NON_LINE [U4.51.03]). 
   En effet, le calcul de la charge limite requiert beaucoup d'itrations de recherche linaire (de l'ordre de 50) 
   et d'itrations de Newton (de l'ordre de 50).""",
   num_lc         = 17,
   nb_vari        = 1,
   nom_vari       = ('VIDE',),
   mc_mater       = ('ECRO_LINE'),
   deformation    = ('PETIT', 'PETIT_REAC', 'GROT_GDEP',),
   schema         = ('IMPLICITE',),
   modelisation   = ('3D', 'AXIS', 'D_PLAN'),
   nom_varc       = ('TEMP'),
   type_matr_tang = ('PERTURBATION', 'VERIFICATION'),
   proprietes     = None,
)

